<?php
/*
 *  This file and its contents are limited to the author only.
 *  See the file "LICENSE" for the full license governing this code.
 *  Differing and additional copyright notices are defined below.
 * ----------------------------------------------------
 * 04.01.2014
 * File: PasswordHash.Benchmark.phtml
 * Encoding: UTF-8
 * Project: AppStatic 
 * */

namespace AppStatic\Security;

use AppStatic\Core\String;
use AppStatic\Globalization\DateTimeUtility;
use AppStatic\Security\Cryptography\PasswordHash;
use AppStatic\Security\Cryptography\Power;

function Print_AlgorithmList()
{
    global $actionList, $hashAlgorithm;
    foreach ($actionList as $item) {
        $checked = $hashAlgorithm == $item ? 'checked' : '';
        echo <<<HTML
<label>
    <input type="radio" name="hashAlgorithm" value="$item" onChange="this.form.submit();" $checked/>$item
</label>
HTML;
    }
}

function PrintTH(array $values)
{

    $line = implode(<<<HTML
</th><th>
HTML
        , array_map(
            function ($value) {
                if (String::EndsWidth($value, '_'))
                    $value = substr($value, 0, strlen($value) - 1);
                return $value;
            },
            $values));

    echo <<<HTML
<th>$line</th>
HTML;
}

function PrintTR(array $values)
{
    echo <<<HTML
<tr valign="top" class="{$values['Algorithm']}">
HTML;

    foreach ($values as $key => $value) {
        if ($value instanceof Power)
            $value = "<span style='white-space: nowrap'>2<sup><b>({$value->Exponent})</b></sup> = $value</span>";
        if (String::EndsWidth($key, '_'))
            echo <<<HTML
<td>$value</td>
HTML;
        else
            echo <<<HTML
<td class="wrap">$value</td>
HTML;
    }

    echo <<<HTML
</tr>
HTML;
}

$passwordHashClassName = PasswordHash::getClassName();
$title = $passwordHashClassName . " - Cost Factor Benchmark";

/*
 Rather than using a fixed default cost, use a Moore's Law sliding constant.
 Given that we know that when the BCrypt algorithm was published in 1999, a "normal user" has
 a cost factor of 6 (i.e. 2^6 = 64 rounds).

 Moore's Law says computing power doubles every 18 months,
 that means the cost factor should increase by one every 18 months
*/
$months = DateTimeUtility::DateTimespan(date('2000-1-1'), date('Y-m-d'));

/*
Give everyone 5 years (60 months) to buy the new computers.
This was determined empirically on 3/9/2015 so that the
cost today is 12 (900 ms), rather than 16 (14.6 seconds)
*/
$months = $months - 60;
$rounds = 64 * pow(2, $months / 18);
$mooresLaw = floor(log($rounds) / log(2));
?>
<!DOCTYPE html>
<!--[if lt IE 7]>
<html class="no-js lt-ie9 lt-ie8 lt-ie7" xml:lang="en-GB" lang="en-GB"> <![endif]-->
<!--[if IE 7]>
<html class="no-js lt-ie9 lt-ie8" xml:lang="en-GB" lang="en-GB"> <![endif]-->
<!--[if IE 8]>
<html class="no-js lt-ie9" xml:lang="en-GB" lang="en-GB"> <![endif]-->
<!--[if gt IE 8]><!-->
<html class="no-js" xml:lang="en-GB" lang="en-GB"> <!--<![endif]-->
<head>
    <meta charset="utf-8">
    <link rel="stylesheet" media="screen, projection" type="text/css" href="/css/screen.css">
    <link rel="stylesheet" type="text/css" href="PasswordHash.Benchmark.css"/>
    <title><?php echo $title; ?></title>
    <link href="/favicon.ico" rel="shortcut icon" type="image/x-icon"/>
</head>
<body>
<h1><?php echo $title; ?><br/>
    <small>With this benchmark you can calibrate the password hash cost factor for
        all <?php echo $passwordHashClassName; ?> providers.
    </small>
</h1>
<form id="benchmarkActions" method="get" target="_self" action="">
    <p>
        <?php Print_AlgorithmList(); ?>
    </p>

    <p>
        <label>
            <input type="checkbox" name="twofishCrypt" value="1" onChange="this.form.submit();"
                <?php /** @var boolean $twofishCrypt */
                if ($twofishCrypt) echo 'checked'; ?>/>Twofish Encrypted
        </label>
    </p>

    <p>
        Regarding Moore's Law, the today's BCrypt cost factor should be <?php echo $mooresLaw; ?>.<br/>
    </p>
</form>
<table id="benchmarks" cellspacing="0">
    <thead align="left" valign="top">
    <tr><?php /** @var array $results */
        PrintTH(array_keys($results[0])); ?></tr>
    </thead>
    <?php array_map('\AppStatic\Security\PrintTR', array_values($results)); ?>
</table>
</body>
</html>